package type3;

import java.util.Set;
import java.util.stream.Collectors;

public class FiniteStateMachine {

	private Set<State> current;

	public FiniteStateMachine(State initial) {
		this.current = Set.of(initial);
	}

	public FiniteStateMachine(Set<State> current) {
		this.current = current;
	}

	public FiniteStateMachine switchStates(String c) {
		return new FiniteStateMachine(
				this.current.stream().map(s -> s.transit(c)).flatMap(Set::stream).collect(Collectors.toSet()));
	}

	public boolean canStop() {
		return this.current.stream().anyMatch(State::isFinal);
	}

	@Override
	public String toString() {
		return this.current.toString();
	}

}
